# coding=utf-8
# --------------------------------------------------------------------------
# Copyright (c) Microsoft and contributors.  All rights reserved.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
# http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
#
# See the License for the specific language governing permissions and
# limitations under the License.
#
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.
# --------------------------------------------------------------------------

from .sub_resource import SubResource


class ApplicationGatewayProbe(SubResource):
    """
    Probe of application gateway

    :param str id: Resource Id
    :param str name: Gets name of the resource that is unique within a
     resource group. This name can be used to access the resource
    :param str etag: A unique read-only string that changes whenever the
     resource is updated
    :param str protocol: Gets or sets the protocol. Possible values include:
     'Http', 'Https'
    :param str host: Gets or sets the host to send probe to
    :param str path: Gets or sets the relative path of probe
    :param int interval: Gets or sets probing interval in seconds
    :param int timeout: Gets or sets probing timeout in seconds
    :param int unhealthy_threshold: Gets or sets probing unhealthy threshold
    :param str provisioning_state: Gets or sets Provisioning state of the
     backend http settings resource Updating/Deleting/Failed
    """

    _required = []

    _attribute_map = {
        'name': {'key': 'name', 'type': 'str'},
        'etag': {'key': 'etag', 'type': 'str'},
        'protocol': {'key': 'properties.protocol', 'type': 'ApplicationGatewayProtocol', 'flatten': True},
        'host': {'key': 'properties.host', 'type': 'str', 'flatten': True},
        'path': {'key': 'properties.path', 'type': 'str', 'flatten': True},
        'interval': {'key': 'properties.interval', 'type': 'int', 'flatten': True},
        'timeout': {'key': 'properties.timeout', 'type': 'int', 'flatten': True},
        'unhealthy_threshold': {'key': 'properties.unhealthyThreshold', 'type': 'int', 'flatten': True},
        'provisioning_state': {'key': 'properties.provisioningState', 'type': 'str', 'flatten': True},
    }

    def __init__(self, id=None, name=None, etag=None, protocol=None, host=None, path=None, interval=None, timeout=None, unhealthy_threshold=None, provisioning_state=None):
        super(ApplicationGatewayProbe, self).__init__(id=id)
        self.name = name
        self.etag = etag
        self.protocol = protocol
        self.host = host
        self.path = path
        self.interval = interval
        self.timeout = timeout
        self.unhealthy_threshold = unhealthy_threshold
        self.provisioning_state = provisioning_state
